## Update attribute

### cURL

```bash
curl --request PUT \
  --url https://api.fabric.inc/v3/attributes/{attributeId} \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --header 'x-fabric-tenant-id: <x-fabric-tenant-id>' \
  --data '
{
  "name": "Brand",
  "values": [
    "CHS",
    "SOMA",
    "WHBM"
  ]
}
'```

### Python

```python
import requests

url = "https://api.fabric.inc/v3/attributes/{attributeId}"

payload = {
    "name": "Brand",
    "values": ["CHS", "SOMA", "WHBM"]
}
headers = {
    "x-fabric-tenant-id": "<x-fabric-tenant-id>",
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.put(url, json=payload, headers=headers)

print(response.text)
```

### JavaScript

```javascript
const options = {
  method: 'PUT',
  headers: {
    'x-fabric-tenant-id': '<x-fabric-tenant-id>',
    Authorization: 'Bearer <token>',
    'Content-Type': 'application/json'
  },
  body: JSON.stringify({name: 'Brand', values: ['CHS', 'SOMA', 'WHBM']})
};

fetch('https://api.fabric.inc/v3/attributes/{attributeId}', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));
```

### PHP

```php
$curl = curl_init();

curl_setopt_array($curl, [
  CURLOPT_URL => "https://api.fabric.inc/v3/attributes/{attributeId}",
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 30,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "PUT",
  CURLOPT_POSTFIELDS => json_encode([
    'name' => 'Brand',
    'values' => [
        'CHS',
        'SOMA',
        'WHBM'
    ]
  ]),
  CURLOPT_HTTPHEADER => [
    "Authorization: Bearer <token>",
    "Content-Type: application/json",
    "x-fabric-tenant-id: <x-fabric-tenant-id>"
  ],
]);

$response = curl_exec($curl);
$err = curl_error($curl);

curl_close($curl);

if ($err) {
  echo "cURL Error #:" . $err;
} else {
  echo $response;
}
```

### Go

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

url := "https://api.fabric.inc/v3/attributes/{attributeId}"

payload := strings.NewReader("{\n  \"name\": \"Brand\",\n  \"values\": [\n    \"CHS\",\n    \"SOMA\",\n    \"WHBM\"\n  ]\n}")

req, _ := http.NewRequest("PUT", url, payload)

req.Header.Add("x-fabric-tenant-id", "<x-fabric-tenant-id>")
	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

res, _ := http.DefaultClient.Do(req)

defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

fmt.Println(string(body))
}
```

### Java

```java
HttpResponse<String> response = Unirest.put("https://api.fabric.inc/v3/attributes/{attributeId}")
  .header("x-fabric-tenant-id", "<x-fabric-tenant-id>")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"name\": \"Brand\",\n  \"values\": [\n    \"CHS\",\n    \"SOMA\",\n    \"WHBM\"\n  ]\n}")
  .asString();
```

### Ruby

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.fabric.inc/v3/attributes/{attributeId}")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Put.new(url)
request["x-fabric-tenant-id"] = '<x-fabric-tenant-id>'
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"name\": \"Brand\",\n  \"values\": [\n    \"CHS\",\n    \"SOMA\",\n    \"WHBM\"\n  ]\n}"

response = http.request(request)
puts response.read_body
```

### Response

- **200**  - OK

```json
{
  "id": 1000002,
  "name": "Brand",
  "values": [
    "CHS",
    "SOMA",
    "WHBM"
  ],
  "createdAt": "2019-08-20T14:15:22.000Z",
  "updatedAt": "2019-08-20T14:15:22.000Z",
  "isDeleted": false
}
```

- **400**  - Bad Request

```json
{
  "type": "ATTRIBUTE_NAME_EXISTS",
  "message": "Attribute name already exists"
}
```

- **401**  - Unauthorized

```json
{
  "type": "UNAUTHORIZED",
  "message": "Invalid credentials"
}
```

- **404**  - Not Found

```json
{
  "type": "ATTRIBUTE_NOT_FOUND",
  "message": "No attribute with this ID is found"
}
```

- **500**  - Internal Server Error

```json
{
  "type": "INTERNAL_SERVER_ERROR",
  "message": "Internal server error"
}
```

### Authorizations

- **Authorization**
 - Type: string
 - Required: Bearer authentication header of the form `Bearer <token>`, where `<token>` is your auth token.

### Headers

- **x-fabric-tenant-id**
 - Type: string
 - Required: A header used by fabric to identify the tenant making the request. You must include tenant id in the authentication header for an API request.
 - Required string length: `24`
